

local default_can_dig = function(pos)
	local inv = minetest.get_meta(pos):get_inventory()
	return inv:is_empty("main")
end

local function xdecor_stairs_alternative(nodename, def)
		local mod, name = nodename:match("(.*):(.*)")

		for groupname, value in pairs(def.groups) do
			if groupname ~= "cracky"    and groupname ~= "choppy"  and
			   groupname ~= "flammable" and groupname ~= "crumbly" and
			   groupname ~= "snappy" then
				def.groups.groupname = nil
			end
		end

		if minetest.get_modpath("moreblocks") then
			stairsplus:register_all(
				mod,
				name,
				nodename,
				{
					description = def.description,
					tiles = def.tiles,
					groups = def.groups,
					sounds = def.sounds,
				}
			)
		elseif minetest.get_modpath("stairs") then
			stairs.register_stair_and_slab(name,nodename,
				def.groups,
				def.tiles,
				("%s Stair"):format(def.description),
				("%s Slab"):format(def.description),
				def.sounds
			)
		end
	end

function xdecor.register(name, def)
	def.drawtype = def.drawtype or (def.mesh and "mesh") or (def.node_box and "nodebox")
	def.sounds = def.sounds or default.node_sound_defaults()

	if not (def.drawtype == "normal" or def.drawtype == "signlike" or
			def.drawtype == "plantlike" or def.drawtype == "glasslike_framed" or
			def.drawtype == "glasslike_framed_optional") then
		def.paramtype2 = def.paramtype2 or "facedir"
	end

	if def.sunlight_propagates ~= false and
			(def.drawtype == "plantlike" or def.drawtype == "torchlike" or
			def.drawtype == "signlike" or def.drawtype == "fencelike") then
		def.sunlight_propagates = true
	end

	if not def.paramtype and
		(def.light_source or def.sunlight_propagates or
		def.drawtype == "nodebox" or def.drawtype == "mesh") then
		def.paramtype = "light"
	end

	local infotext = def.infotext
	local inventory = def.inventory
	

	minetest.register_node(":xdecor:" .. name, def)

	local workbench = minetest.settings:get_bool("enable_xdecor_workbench")

	if workbench == false and
	  (minetest.get_modpath("moreblocks") or minetest.get_modpath("stairs")) then
		if xdecor.stairs_valid_def(def) then
			xdecor_stairs_alternative("xdecor:"..name, def)
		end
	end
end
